<template>
    <div>
        <div class="chat">
            <div class="messages">
                <div class="message" v-for="(message) in messages">
                    <div class="avatar"></div>
                    <div class="sentBy">{{message.sentBy}}</div>
                    <div class="sentAt">{{new Date(message.sentAt).toTimeString().replace(/\(.*/, "")}}</div>
                    <div class="text">{{message.text}}</div>
                </div>
            </div>
            <div class="group">
                <textarea class="textarea" ref="textarea" @keydown.enter.prevent="sendMessage" rows="1" placeholder="Write a message..."></textarea>
                <button class="send-button" @click="sendMessage"/>
            </div>
        </div>
    </div>
</template>

<script setup>

    import { ref } from "vue";

    defineProps({
        messages: Array,
    });

    const textarea = ref(null);

    const emit = defineEmits(["onChatMessage"]);

    const sendMessage = (event) => {
        let message = textarea.value.value;
        if (message.length > 0 && (event.type === "click" || event.type === "keydown" && event.which === 13)) {
            event.preventDefault();
            emit("onChatMessage", message);
            textarea.value.value = "";
        }
    };

</script>

<style scoped>

    .chat {
        height: 100%;
        flex: 0 0 450px;
        display: flex;
        flex-direction: column;
        background: #fff;
        color: #666;
    }

    .messages {
        flex: 1;
        padding: 15px;
        overflow: auto;
        border-bottom: 1px solid #ccc;
    }

    .message {
        position: relative;
        margin-bottom: 15px;
    }

    .message > .avatar {
        position: absolute;
        width: 40px;
        height: 40px;
        /*border: 1px solid #555;*/
        font-size: 40px;
        background-color: #666;
        -webkit-mask-image: url("../assets/person.svg");
        -webkit-mask-size: cover;
        mask-image: url("../assets/person.svg");
        mask-size: cover;
    }

    .message > .sentBy {
        padding-left: 55px;
        display: inline;
        font-weight: bold;
    }

    .message > .sentAt {
        display: inline;
        font-size: 0.85em;
    }

    .message > .text {
        margin-top: 5px;
        padding-left: 55px;
        line-height: 1.5;
    }

    .group {
        flex: 0 0 auto;
        display: flex;
        flex-direction: row;
        align-items: center;
    }

    .textarea {
        flex: 1;
        background: inherit;
        resize: none;
        outline: none;
        border: none;
        color: inherit;
        padding: 15px 0px 15px 15px;
        font: inherit;
    }

    .send-button {
        display: flex;
        padding: 0;
        line-height: normal;
        text-decoration: none;
        width: 64px;
        height: 34px;
        background-color: #666;
        -webkit-mask-image: url("../assets/send.svg");
        -webkit-mask-repeat: no-repeat;
        -webkit-mask-position: center;
        -webkit-mask-size: contain;
        mask-image: url("../assets/send.svg");
        mask-repeat: no-repeat;
        mask-position: center;
        mask-size: contain;
    }

</style>